/* Generated By:JavaCC: Do not edit this line. ElpParser.java */
package edu.udo.cs.ie.cowbots.elpParser;

import edu.udo.cs.ie.cowbots.elpParser.dlp.*;

import java.util.*;
import java.util.regex.*;
import java.io.*;

/**
 * The grammar of our extended logic program, namely the BNF is 
 * given and started by ANALYSE part.
 * 
 * ELP        ::== (elpExpr)*
 * elpExpr    ::== rule | constraint | fact 
 * rule       ::== head + ":-" + body  + "."
 * constraint ::== ":-" + body  + "."
 * fact       ::= literal + "."  
 * head       ::= orLiteral | literal 
 * orLiteral  ::= literal + "|"+ head
 * body       ::= andLiteral | ("not")? + literal 
 * andLiteral ::= ("not")? + ELPLiteral + "," + body 
 * literal    ::= "~" + atom | atom
 * atom       ::= predicateName | predicateName + "(" + termList+ ")"
 * termList   ::= term | term + "," + termList
 * term  	  ::==  variable | constant | list
 * list	      ::== "[" ( ( term "|" variable ) | ( term ( "," term )* ) )? "]"
 * predicateName is consisted of symbols from {[a,...,z][A,...,Z][0,...,9], _} with an uppercase letter at the beginning.
 * variable is consisted of symbols from {[a,...,z][A,...,Z][0,...,9], _} with an uppercase letter at the beginning.
 * constant is consisted of symbols from {[a,...,z][A,...,Z][0,...,9], _} with an lowercase letter at the beginning.
 * compOp(comparative operator) is consisted of symbols from {"<", " >", "<=", " >=", "==", "!="}.
 * arithOp(arithmetic operator) is consisted of symbols from {"+", "-", "*", "/", "%", "="}.
 */


public class ElpParser implements ElpParserConstants {
  // java compilier use this method to parse disjunctive extended logic programms.
  public static DisjunctiveLogicProgram parse(String fileName) throws ParseException, FileNotFoundException
  {

    ElpParser parser = new ElpParser(new FileInputStream(fileName));
    System.out.println("Reading from standard input...");
    return parser.analyse();

  }



  public static void main(String args [])
  {
    try{
        parse("C:\u005c\u005cUsers/blash/AppData/Roaming/eclipse/workspace/lib_cowbots/src/edu/udo/cs/ie/cowbots/elpParser/testELPs.txt");
    }catch(FileNotFoundException e)
    {
      System.out.println(e.getMessage());
    }
    catch(ParseException f)
    {
                System.out.println(f.getMessage());
        }

  }

// ELP    ::== (elpExpr)* one line for one line begin the parser
  static final public DisjunctiveLogicProgram analyse() throws ParseException {
  DisjunctiveLogicProgram dlp = new DisjunctiveLogicProgram();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IMPLICATION:
      case NEG:
      case NAF:
      case NAME:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      dlpExpr(dlp);
    }
    jj_consume_token(0);
    dlp.saveAs("c:\u005c\u005ctest.dlp");
    {if (true) return dlp;}
    throw new Error("Missing return statement in function");
  }

// elpExpr    ::== rule | constraint | fact 
// rule       ::== head + ":-" + body  + "."
// constraint ::== ":-" + body  + "."
// fact       := literal + "."  
// head       := orLiteral | literal 
// orLiteral  := literal + "|"+ head
// body       := andLiteral | ("not")? + literal 
// andLiteral := ("not")? + ELPLiteral + "," + body 
  static final public void dlpExpr(DisjunctiveLogicProgram dlp) throws ParseException {
  DLPLiteral h;
  DLPLiteral b;

  DLPRule r = new DLPRule(0, 0);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NEG:
    case NAF:
    case NAME:
      // fact is in here or a rule which has only one literal for its head.
                                  h = literal(dlp);
                              r.addHead(h);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PERIOD:
        jj_consume_token(PERIOD);
        break;
      case OR:
        label_2:
        while (true) {
          jj_consume_token(OR);
          h = literal(dlp);
                                    r.addHead(h);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case OR:
            ;
            break;
          default:
            jj_la1[1] = jj_gen;
            break label_2;
          }
        }
        jj_consume_token(IMPLICATION);
        b = literal(dlp);
                         r.addBody(b);
        label_3:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[2] = jj_gen;
            break label_3;
          }
          jj_consume_token(COMMA);
          b = literal(dlp);
                             r.addBody(b);
        }
        jj_consume_token(PERIOD);
                             r.resolve();
                             dlp.addDlpRule(r);
        break;
      case IMPLICATION:
        jj_consume_token(IMPLICATION);
        b = literal(dlp);
                         r.addBody(b);
        label_4:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[3] = jj_gen;
            break label_4;
          }
          jj_consume_token(COMMA);
          b = literal(dlp);
                             r.addBody(b);
        }
        jj_consume_token(PERIOD);
                             r.resolve();
                             dlp.addDlpRule(r);
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    case IMPLICATION:
      jj_consume_token(IMPLICATION);
      b = literal(dlp);
                         r.addBody(b);
      label_5:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_5;
        }
        jj_consume_token(COMMA);
        b = literal(dlp);
                             r.addBody(b);
      }
      jj_consume_token(PERIOD);
                             r.resolve();
                             dlp.addDlpRule(r);
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
     r.resolve();
     dlp.addDlpRule(r);
  }

  static final public DLPLiteral literal(DisjunctiveLogicProgram dlp) throws ParseException {
  DLPAtom a;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAME:
      a = atom(dlp);
    {if (true) return a.getLiteral();}
      break;
    case NEG:
      jj_consume_token(NEG);
      a = atom(dlp);
   // instead of new ELPAtom(a) should be here directly
   // a negative literal with its atom producted.
    {if (true) return new DLPNegLiteral(a);}
      break;
    case NAF:
      jj_consume_token(NAF);
      a = atom(dlp);
    {if (true) return new DLPNotLiteral(a.getLiteral());}
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

// atom production
  static final public DLPAtom atom(DisjunctiveLogicProgram dlp) throws ParseException {
  Token p;
  // only used What if we wana see the list of term is a term
  // alternative handling
  List<DLPTermList> tls = new ArrayList<DLPTermList>();
  DLPTermList t = new DLPTermList();
    p = jj_consume_token(NAME);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      t = termList(dlp);
                    tls.add(t);
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
                  Predicate pred = new Predicate(p.image);
                // what if arithmetic or comparative term exists, then tls
                // should be used
                {if (true) return new DLPAtom(pred, t);}
    throw new Error("Missing return statement in function");
  }

/* termList   ::= term | term + "," + termList 
 */
  static final public DLPTermList termList(DisjunctiveLogicProgram dlp) throws ParseException {
        Token p;
    List<DLPTerm> terms = new ArrayList<DLPTerm>();
    DLPTerm t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NAME:
      t = term(dlp);
                  terms.add(t);
      label_6:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_6;
        }
        jj_consume_token(COMMA);
        t = term(dlp);
                          terms.add(t);
      }
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
                  DLPTermList termList = new DLPTermList(terms);
                  dlp.addTermList(terms);
                  {if (true) return termList;}
    throw new Error("Missing return statement in function");
  }

/** TERM	::== VARIABLE | CONSTANT | LIST
  */
  static final public DLPTerm term(DisjunctiveLogicProgram dlp) throws ParseException {
        Token t;
    // Term analyse
      //(
              t = jj_consume_token(NAME);
                                if(Pattern.compile("^[A-Z]").matcher(t.image).find())
                                                        {if (true) return new DLPVariable(t.image);}

                                DLPConstant c = new DLPConstant(t.image);

                                  {if (true) return c;}
    throw new Error("Missing return statement in function");
  }

  static private boolean jj_initialized_once = false;
  /** Generated Token Manager. */
  static public ElpParserTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  /** Current token. */
  static public Token token;
  /** Next token. */
  static public Token jj_nt;
  static private int jj_ntk;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[11];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x7400,0x800,0x100,0x100,0xe00,0x100,0x7400,0x7000,0x40,0x100,0x4000,};
   }

  /** Constructor with InputStream. */
  public ElpParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public ElpParser(java.io.InputStream stream, String encoding) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ElpParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  static public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  static public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public ElpParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser. ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ElpParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public ElpParser(ElpParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser. ");
      System.out.println("       You must either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(ElpParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  static private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  static final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  static private int[] jj_expentry;
  static private int jj_kind = -1;

  /** Generate ParseException. */
  static public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[21];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 21; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  static final public void enable_tracing() {
  }

  /** Disable tracing. */
  static final public void disable_tracing() {
  }

}
