package edu.udo.cs.ie.cowbots.elpParser.dlp;


import edu.udo.cs.ie.cowbots.logic.NegLiteral;

/**
 * class for strict negated literals * 
 * @author Wei
 * @see super class {@link NegLiteral} and interface {@link DLPLiteral}
 */
public class DLPNegLiteral extends NegLiteral implements DLPLiteral {


	// new attribute 
	boolean litIsFact = false;
	
	public DLPNegLiteral(DLPAtom a) {
		super(a);
	}
	
	/**
	 * check this literal whether a fact or not.   
	 * @return {@link DLPNegLiteral#litIsFact}
	 */
	public boolean isLitAfact(){
		return litIsFact;
	}
	
	@Override
	public DLPLiteral getLiteral() {
		return this;
	}

	@Override
	public boolean isAtom() {
		return false;
	}

	@Override
	public boolean isDefaultNegated() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isStrictNegated() {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public DLPAtom getAtom() {
		return (DLPAtom) this.atom;
	}
	
	public String toString() {
		return "~"+atom.toString();
	}

	@Override
	public boolean isArithmetic() {
		return false;
	}
	
	@Override
	public boolean equals(Object o) {
		if (!(o instanceof DLPNegLiteral))
			return false;

		DLPNegLiteral nl = (DLPNegLiteral) o;
		
		return this.atom.equals( nl.getAtom() );
	}

	@Override
	public boolean LitIsAfact(boolean b) {
		return litIsFact = b;
	}


}
