package edu.udo.cs.ie.cowbots.internalActions.experimental2;

import java.util.ArrayList;
import java.util.Collections;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.internalActions.scout.astar;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.Term;
import jason.stdlib.print;

/**
 * 
 * @author dhoelzgen
 *
 */
public class exAstar extends DefaultInternalAction {
	
	/**
	 * Uses A*, but switchwes on some experimental features:
	 * * Tries to avoid the field in front of the cow (get's driving direction)
	 * * Tries to adjust the targets position, so it's not on an obstacle
	 * * (deactivated) Tries to get not to close to obstacles
	 */
	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		try {
			astar pathfinder = new astar();
			pathfinder.experimental_cowsight = true;
			pathfinder.experimental_obstacle = false;
			pathfinder.experimental_newposition = true;
			pathfinder.addCowWeight = 10000;
			pathfinder.addSightWeight = 10000;
			return pathfinder.execute(ts, un, args);
		}catch(ArrayIndexOutOfBoundsException e){
			//TODO:Irgendwas mit dem Error machen
			System.err.println("EX A*: Could not find way");
		}  
		catch (Throwable e) {
			System.out.println("astar error: " + e);
			e.printStackTrace();
		}
		return false;
	}

}
