package edu.udo.cs.ie.cowbots.internalActions.experimental2;

import java.awt.Point;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.bdi.brf.BeliefSet;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;


/**
 * 
 * @author dhoelzgen
 *
 */
public class exSwitchPosition extends DefaultInternalAction {
	
	/**
	 * Uses the planners getSwitchPositio to return either the switch position
	 * on the agents side of the fence, or at least a point where the
	 * agent should look for the switch.
	 */
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {		
		int aX = (int) ((NumberTerm) args[0]).solve();
		int aY = (int) ((NumberTerm) args[1]).solve();
		
		int sX = (int) ((NumberTerm) args[2]).solve();
		int sY = (int) ((NumberTerm) args[3]).solve();
		
		ICowbot cowbot = (ICowbot) ts.getAg();
		BeliefSet bs = cowbot.getEpistemicState().getBeliefSet();
		GridMap map = cowbot.getEpistemicState().getMap();
		
		exCreatePlan planner = new exCreatePlan();
		planner.fillGatePositions(ts);
		Point sPos = planner.getSwitchPosition(bs, new Point(aX, aY), new Point(sX, sY), map);
		
		System.err.println(String.format("Position with %s", sPos));
		
		un.unifies(args[4], new NumberTermImpl(sPos.x));
		un.unifies(args[5], new NumberTermImpl(sPos.y));
		
		return true;
	}
}
