package edu.udo.cs.ie.cowbots.internalActions.scout;

import java.awt.Point;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.planer.makePlan;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.*;
import jason.asSyntax.*;
import jason.asSemantics.*;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;


/**
 * Standalone-class for setting the "worldknown"-predicate in the scout-role
 * (functionality also included in getScoutCandidate)
 * 
 * @author bienek, jablkowski
 *
 */

public class considerWorldknown extends DefaultInternalAction {

	GridMap map;
	ICowbot cowbot;
	int WorldKnownThreshold;
	
	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		
		cowbot = (ICowbot) ts.getAg();
		map = cowbot.getEpistemicState().getMap();
		
		//threshold for worldknown to be set
		 WorldKnownThreshold = 1000;
		
		
		consider(ts);
		return true;
	}
	/**
	 * Utility function for counting the number of unexploreds
	 * and comparing it to the WorldKnownThreshold
	 * 
	 * @param ts the Agents TransitionSystem
	 */
		private void consider(TransitionSystem ts){
			
			int count=0;
			for (int y = 0; y < map.height(); y++) {
				for (int x = 0; x < map.width(); x++) {
					if (map.getContent(x, y).getAtom().getTerm(0).equals(
							"unexplored")) {
						count++;
					}
				}
		   }
			
        //adds a new Belief "worldknown" into the BB of the Agent, if the list of "unexplored"s is smaller than the threshold
			if (count <= WorldKnownThreshold) {
				try{ts.getAg().addBel(Literal.parseLiteral("worldknown"));}
			    catch(Exception E) {}
			}
		}
			
}
		
