package edu.udo.cs.ie.cowbots.internalActions.scout;

import java.awt.Point;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.planer.makePlan;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.*;
import jason.asSyntax.*;
import jason.asSemantics.*;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;

/**
 * Class to calculate the next fence the group needs to pass
 * 
 * @author bienek, jablkowski
 */
public class getRelevantFence extends DefaultInternalAction {

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
	     
		 int xcoord = (int) ((NumberTerm) args[0]).solve();
	 	 int ycoord = (int) ((NumberTerm) args[1]).solve();
	 	 String dir =  args[2].toString();
	 	 
	 	 Point p = calculateFenceCoordinates(xcoord, ycoord, dir);
	 	 
	 	un.unifies(args[3], new NumberTermImpl(p.x));
		un.unifies(args[4], new NumberTermImpl(p.y));
				
		return true;
		}
	
	
	/**
	 * Utility function, used to calculate the coordinates of the next cell valued "fence",
	 * starting from the agents fenceopenwaypoint following the wp's "ToDirection"
	 * (the whole fence is then constructed by dlv)
	 * @param x the wp's X-coordinate
	 * @param y the wp's Y-coordinate
	 * @param z the wp's "ToDirection"
	 * @return	Point encoding the coordinates
	 */
	private Point calculateFenceCoordinates(int x,int y,String z){
		int fencex= 0;
		int fencey= 0;
		
		
		if (z.equals("north")) {fencex = x; fencey = y-1;}
		else if (z.equals("northeast")) {fencex = x+1; fencey = y-1;}
		else if (z.equals("east")) {fencex = x+1; fencey = y;}
		else if (z.equals("southeast")) {fencex = x+1; fencey = y+1;}
		else if (z.equals("south")) {fencex = x; fencey = y+1;}
		else if (z.equals("southwest")) {fencex = x-1; fencey = y+1;}
		else if (z.equals("west")) {fencex = x-1; fencey = y;}
		else {fencex = x-1; fencey = y-1;}
		
		
		return new Point(fencex, fencey);
	}
	
	
}
