package edu.udo.cs.ie.cowbots.planer;

import jason.JasonException;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;

public class getMyNextPositionsCoordinates extends DefaultInternalAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6418798016322240369L;
	public static String currentPlan;

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		
		String goalToPlan = args[0].toString();

		// Parameter in Args: T, XCoord, YCoord, FromDirection, ToDirection,
		// Formationpos, AgentsCount, GeneratedPlan, Radius, MyXCoord, MyYCoord
		// elpLiteralGoal = getNewFormationPos(goalToPlan, args);
		// System.out.println("Unsere neuen Positionen (drivenCow): " +
		// elpLiteralGoal.toString() );

		int coordinateX = (int) ((NumberTerm) args[1]).solve();
		int coordinateY = (int) ((NumberTerm) args[2]).solve();
		String direction;
		if (goalToPlan.startsWith("drivenCow")) {
			direction = args[3].toString();
		} else if (goalToPlan.startsWith("rotateFormation")) {
			direction = args[4].toString();
		} else {
			throw new JasonException(
					"Der Aufruf von makePlan mit dem Parameter:"
							+ goalToPlan
							+ " Somit k�nnen keine Koordinaten berechnet werden.");
		}

		int formationPos = (int) ((NumberTerm) args[5]).solve();
		int agentsCount = (int) ((NumberTerm) args[6]).solve();
		
		//special case: leader should stand in the middle
		if (formationPos==0)
		{
			formationPos = (int) Math.ceil(agentsCount / 2);
		}
		else if (formationPos <= (int) Math.ceil(agentsCount / 2))
		{
			--formationPos;
		}
		
		//wir leader + helperliste.size
		agentsCount++;
		double radius = (int) ((NumberTerm) args[7]).solve();		
		double degree = 180 / (agentsCount - 1);
		double myDegree = degree * (formationPos);
		int directionOffset = 0;
		int endPosX = 0;
		int endPosY = 0;
		//na, Na oder sonstwas wird zu south! 
		
		if (direction.equals("south")) {
			directionOffset = 0;
		}else if (direction.equals("southeast")) {
			directionOffset = 45;
		} else if (direction.equals("east")) {
			directionOffset = 90;
		} else if (direction.equals("northeast")) {
			directionOffset = 135;
		} else if (direction.equals("north")) {
			directionOffset = 180;
		} else if (direction.equals("northwest")) {
			directionOffset = 225;
		}else if (direction.equals("west")) {
			directionOffset = 270;
		}else if (direction.equals("southwest")) {
			directionOffset = 315;
		}else if (direction.equalsIgnoreCase("na")) {
			directionOffset = 0;
		} else {
			System.out
					.println("ACHTUNG falsche Richtungsangabe, Treiben in Richtung "
							+ direction + " wird nicht unterst�tzt.");
		}
		//na, nA etc.
		// System.out.println("Mydegree+offset=" + (myDegree+directionOffset));
		double myDegreeWithOffset = Math.toRadians(myDegree + directionOffset);
		endPosX = coordinateX + (int) (Math.cos(myDegreeWithOffset) * radius);
		endPosY = coordinateY + (int) (Math.sin(myDegreeWithOffset) * radius);
		while(endPosX<0){endPosX++;}
		while(endPosY<0){endPosY++;}
		un.unifies(args[8], new NumberTermImpl(endPosX));
		un.unifies(args[9], new NumberTermImpl(endPosY));
		return true;
	}

}

