package edu.udo.cs.ie.cowbots.planer;

/*
 * This class calls PlanGenerator to get a Plan and then places it on the intended means
 * If only Waypoints are generated it returns the number of new WPs
 * 
 * @author Alex, Elly, Michael
 * 
 */

import edu.udo.cs.ie.cowbots.agent.CowbotAgent;
import edu.udo.cs.ie.cowbots.logic.ELP;
import edu.udo.cs.ie.cowbots.logic.ELPAtom;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.*;
import jason.asSemantics.*;
import jason.asSyntax.*;
import jason.asSyntax.PlanBody.BodyType;

public class makePlan extends DefaultInternalAction {

	private static final long serialVersionUID = 6418798016322240369L;
	public static String currentPlan;
	static double radius = 5;
	private PlanGenerator planGen;

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {

		String myself = ts.getUserAgArch().getAgName();
		System.out.println(myself + " " + args[0].toString());
		
		// Keyword(reach,dynamic etc) plus Zielobjekt(Kuh,Agent)
		String task[] = {args[0].toString(), args[3].toString()};
		
		// toX, toY sind die Zielkoordinaten
		String toX = args[1].toString();
		String toY = args[2].toString();
		
		System.out.println(myself + " Entering makePlan " + task[0]);
		
		if (planGen == null)
			planGen = new PlanGenerator();
		
		ELPLiteral goal;

		if (task[0].startsWith("reach") || task[0].equals("scouted")|| task[0].equals("driving")) {
			String who = task[1];
			goal = new ELPAtom("ison", who, toX, toY);

//			//delete old plan			
			if(ts.getAg().getPL().get("aStarPlan") != null){
				System.out.println(myself +" deleting plan " + currentPlan.toString());
				ts.getAg().getPL().remove("aStarPlan");	
			}
			currentPlan = "";
			
			//System.out.println("Ziel: " + goal.toString());
			currentPlan = planGen.generate(ts, goal, task);

			// im Fall, dass WPs generiert wurden, soll deren Anzahl zurck gegeben werden
			
			if (currentPlan.startsWith("NumberOfWaypoints")) {
				//System.out.println("NumberofWPs " +currentPlan);
				String[] number = currentPlan.split(";");
				System.out.println("Anzahl: " + number[1]);
				un.unifies(args[4], new NumberTermImpl(Integer.parseInt(number[1])));
			} else 
			{ // sonst wird der Plan abgelegt
				//System.out.println("Versuche Plan abzulegen: " +currentPlan);
			
				Plan thePlan = ASSyntax.parsePlan(currentPlan);
				Pred p = new Pred("aStarPlan");
				thePlan.setLabel(p);
				ts.getAg().getPL().add(thePlan);

			}

		}	//dynamisches Planen mit HigherPlanner 
			else if (task[0].startsWith("dynamic")){
			HigherPlanner hp = new HigherPlanner();
			String sendPlan = hp.generate(ts, task);
			//System.out.println("von HigherPlanner erstellter Plan: " + sendPlan);
			
			if(ts.getAg().getPL().get("sendPlan") != null){
				//System.out.println(" deleting plan " + currentPlan.toString());
				ts.getAg().getPL().remove("sendPlan");	
			}
			
			// neuen Plan der PL hinzufgen
			Plan thePlan = ASSyntax.parsePlan(sendPlan);
			Pred p = new Pred("sendPlan");
			thePlan.setLabel(p);
			ts.getAg().getPL().add(thePlan);
		
		}	//Relikt?!?
			else if (task[0].startsWith("drivenCow")|| task[0].startsWith("rotateFormation")) {
			// ToDo: Konfiguration fr Ziele
			ELPLiteral elpLiteralGoal = null;
			StringTermImpl myplan = null;

			// Parameter in Args: T, XCoord, YCoord, FromDirection, ToDirection,
			// Formationpos, AgentsCount, GeneratedPlan
			String obj = args[3].toString();
			int x = (int) ((NumberTerm) args[1]).solve();
			int y = (int) ((NumberTerm) args[2]).solve();

			elpLiteralGoal = new ELPAtom("ison", obj, x + "", y + "");
			System.out.println("zu planendes literal:"
					+ elpLiteralGoal.toString());
			myplan = new StringTermImpl(planGen.generate(ts, elpLiteralGoal,
					task));
			un.unifies(args[4], myplan);

			// System.out.println("Unsere neuen Positionen (drivenCow): " +
			// elpLiteralGoal.toString() );
		}

		else {

			throw new JasonException(
					"Der Aufruf von makePlan mit dem Parameter:" + task
							+ " Somit kann kein Plan erzeugt werden.");

		}

		// un.unifies(new StringTermImpl(planGen.generate(ts, elpLiteralGoal)),
		// args[1]);
		return true;
	}

	/**
	 * this method puts the plan (in form of a string) on jason's intended means
	 * 
	 * @param plan
	 * @param ts
	 * @throws Exception
	 */
	private void placePlanOnIntendedMeans(String plan, TransitionSystem ts)
			throws Exception {
		BodyType BT;
		// Stack<IntendedMeans> im = ts.getC().getSelectedIntention().getIMs();
		IntendedMeans im = ts.getC().getSelectedIntention().peek();
		plan = plan.replaceAll("\\\\ \"", "");
		plan = plan.trim();
		// System.out.println("trimmed plan: "+plan);
		String steps[] = plan.split(";");
		System.out.println("planlnge: " + steps.length);
		PlanBody newpb = null;
		for (int i = 0; i <= steps.length - 2; i++) {
			String currentStep = steps[i].trim();
			if (i == 0) {
				currentStep = currentStep.substring(1);
			}
			if (currentStep.length() <= 0)
				continue;

			if (currentStep.startsWith("?")) {
				currentStep = currentStep.substring(1);
				BT = BodyType.test;
			} else if (currentStep.startsWith("-")) {
				currentStep = currentStep.substring(1);
				BT = BodyType.delBel;
			} else {
				BT = BodyType.action;
			}

			// Plan muss vollstndig aufgebaut werden, bevor er
			// als nchster Schritt zu den intended means darf.
			if (newpb == null)
				newpb = new PlanBodyImpl(BT, ASSyntax.parseTerm(currentStep));
			else
				newpb.add(new PlanBodyImpl(BT, ASSyntax.parseTerm(currentStep)));
			// System.out.println("new plan body: " + newpb);
			// im.insertAsNextStep(newpb);
		}
		im.insertAsNextStep(newpb);
	}

}
