package edu.udo.cs.ie.cowbots.ui.theme;

import java.awt.*;

/**
 * color table for cowbot scenario entities.
 * 
 * @author Thomas
 *
 */
public class CowbotColorTable {

	// entity indices
	public static final	int		C_ALLY	=	0;
	public static final int		C_ENEMY =	1;
	public static final int		C_CORRALOUR	= 2;
	public static final int		C_CORRALENEMY = 3;
	public static final int		C_EMPTY = 4;
	public static final int		C_OBSTACLE = 5;
	public static final int		C_FENCE = 6;
	public static final int		C_SWITCH = 7;
	public static final int		C_COW = 8;
	public static final int		C_ACTIVEAGENT = 9;
	
	Color	colors[] = null;
	
	/**
	 * constructs a new cowbotcolortable instance,
	 * and assigns default colors to world entities.
	 */
	public CowbotColorTable() {
		colors = new Color[10];
		colors[C_ALLY] = Color.BLUE;
		colors[C_ENEMY] = Color.RED;
		colors[C_CORRALOUR] = new Color(128,128,255);
		colors[C_CORRALENEMY] = new Color(255,128,128);
		colors[C_EMPTY] = new Color(32,128,32);
		colors[C_OBSTACLE] = Color.LIGHT_GRAY;
		colors[C_FENCE] = Color.GRAY;
		colors[C_SWITCH] = Color.YELLOW;
		colors[C_COW] = Color.WHITE;
		colors[C_ACTIVEAGENT] = Color.GREEN;
	}
	
	/**
	 * returns the color associated with an entity
	 * 
	 * @param index	entity index
	 * @return color value
	 */
	public Color getColor(int index) {
		return colors[index];
	}
}
