//Initial beliefs
{include ("shared_knowledge.asl")}
{include ("walker.asl")} 
{include ("leader.asl")} 
{include ("helper.asl")} 
{include ("cbfunk.asl")} 

// necessary literals
// rotateDirection(Dir, CD, CE) rotating a given cardinal direction CD in the direction Dir results in cardinal direction CE  
rotateDirection(right, north, east).
rotateDirection(right, east, south).
rotateDirection(right, south, west).
rotateDirection(right, west, north).
rotateDirection(left, north, west).
rotateDirection(left, east, north).
rotateDirection(left, south, east).
rotateDirection(left, west, south).

// toggleSwitch(Side, CD, X, Y) when toggling a switch from Side at a gate you are facing CD, 
// you have to step X-1 and Y-1 back from the switch coordinates to trigger it
toggleSwitch(outside, north, 1, 0).
toggleSwitch(outside, east, 0, 1).
toggleSwitch(outside, south, 1, 2).
toggleSwitch(outside, west, 2, 1).
toggleSwitch(inside, north, 1, 2).
toggleSwitch(inside, east, 2, 1).
toggleSwitch(inside, south, 1, 0).
toggleSwitch(inside, west, 0, 1).


// relates a cardinal direction with the orthogonal axis
relateAxis(xAxis, north).
relateAxis(xAxis, south).
relateAxis(yAxis, west).
relateAxis(yAxis, east).

// test literals - koennen auskommentiert werden, wenn andere agenten, den dooropener nutzen wollen
radius(4).//fest eingetragen, bis es irgentwann zentral festgelegt wird
step(1).
kwaypoint(fenceopenwp,1,11,5,west,west).
kwaypoint(fenceclosewp,2,3,5,west,west).
ack(ag1, 1, 1, 1, 1).
ack(ag3, 1, 1, 1, 1).
//ack(admetus, 1, 1, 1, 1).
ack(ag4, 1, 1, 1, 1).
ack(ag5, 1, 1, 1, 1).



!dooropeningLeading.

+dummyEvent:true
<-
	true.
	
+!scouted:true
<- //.print("verfolge scouting....");
	.wait(1000).
	

//Plans


+!dooropeningLeading: true
<- 	
	// erzeugt die HelperList - sollte im Kontext anderer Plaene bereits gegeben sein
	.findall(Agent, ack(Agent, _, _, _, _), HelperList );
	.wait(2000);
	//
	// verteilt die Wegpunktpositionen - sollte im Kontext anderer Plaene bereits gegeben sein
	!taskAllocation(drivenCow, fence, HelperList);
	//
	// bringt die Agenten in Formation - sollte im Kontext anderer Plaene bereits gegeben sein
 	?step(Step);
 	?iam(N);
	.send(HelperList, tell, getinformation(N, Step));
	!walkIntoPosition(HelperList);	
	.length(HelperList, AgentsCount);
	!waitForAllAgentsInFormation((AgentsCount - 1), HelperList);
	.abolish(information(_, _));	   	
	//
	
	// ---->>>> Der eigentliche Aufruf der Dooropening Funktion VOR einem Gatter <<<<----
	!dooropeningOutside(HelperList);
	//
	
	// wieder einige Zeilen (Waypointschritt erhoehen, Taskallocation), die im Kontext gegeben sein sollten
	-+step(Step+1);
	!taskAllocation(drivenCow, fence, HelperList);
	//
	
	
	// ---->>>> Der eigentliche Aufruf der Dooropening Funktion NACH einem Gatter <<<<----
	// Das Durchlaufen des Gatters mit den Agenten, die nicht den Switch bet�tigen
	!leadmarching(HelperList, 1); 
	!walkIntoPosition(HelperList);
	.count(isAtSwitch(_), BusyDooropeners);
	!waitForAllAgentsInFormation(((AgentsCount - BusyDooropeners) - 1), HelperList);
	.abolish(information(_, _));	   	
	!dooropeningInside;
	.send(HelperList, tell, fencePassed).
	//


+!walkIntoPosition(HelperList)
<-	   ?step(Step);     
	   ?kwaypoint(WPType,Step,X,Y,FromDirection, ToDirection);	
	   .length(HelperList, AgentsCount);     
	   ?radius(R);
	   //.print(drivenCow,X,Y,FromDirection,ToDirection,Formationpos,AgentsCount,R);
	   !getMyNextPosition(drivenCow, X, Y, FromDirection, ToDirection, 0, AgentsCount, R);
	 
	   //laufe zu dieser Position 
	   ?myNextPositionCoordinates(Xr,Yr);
	   .concat("Helper: Begebe mich in die Position-afterRotate: x=",Xr," y=",Yr,Msr);
	   //!debugPrint(Msr);
	   !setWalkingModi(1,1,1);	
	   -walkingfailed;
	   !walkTo(Xr,Yr);	 
	   ?iam(MyName).
	   //.send(MyName, tell, information(MyName, Step)).
	

	


+!dooropeningOutside(HelperList) 
<-
	!buildDooropenerLiterals(HelperList);
	?agentGroup(Ag, Bg);
	?step(Step);
	?kwaypoint(_,Step,_,_,D,_);
	+doorOpenerToggle(Ag, Bg);
	+doorOpenerToggle(Bg, Ag);
	!leadLookForSwitch(Ag, Bg, D).
	

+!buildDooropenerLiterals(HelperList) : .length(HelperList, AgentCount) & AgentCount = 0 
<- .print("Dooropening alleine nicht moeglich").

	
+!buildDooropenerLiterals(HelperList)
<-

	.length(HelperList, AgentCount);
	.nth(AgentCount - 1, HelperList, Ag);
	.nth(0, HelperList, Bg);
	.print(Ag, " and ", Bg, " are searching");
	+agentGroup(Bg, Ag);
	!buildAgentWing(HelperList).
	
+!buildAgentWing(HelperList)
<-
	.length(HelperList, AgentCount);
	.nth(AgentCount - 1, HelperList, Ag);
	.nth(AgentCount - 2, HelperList, Bg);
	.print(Ag, " and ", Bg, " are a Wing");
	+agentWing(Ag, Bg);
	+agentWing(Bg, Ag);
	.nth(0, HelperList, Cg);
	.nth(1, HelperList, Dg);
	.print(Cg, " and ", Dg, " are a Wing");
	+agentWing(Dg, Cg);
	+agentWing(Cg, Dg).
	
	
	
+!dooropeningInside
<-
	
 	?step(Step);
	?agentGroup(Ag, Bg);
	//.print(Ag,Bg);
	?kwaypoint(_,Step,_,_,D,_);
	//.print(D);
	?currentSwitch(S, X, Y);
	//.print(S, X, Y);
	?closestAgent(ClosestAgent);
	//.print(ClosestAgent);
	?agentWing(ClosestAgent, WingAgent);
	//.print(FarestAgent);
	
	?toggleSwitch(inside, D, X3, Y3);
	//.print(X3,Y3);
	.print("Schicke ", WingAgent, " zu (", X + X3 -1, ",", Y + Y3 -1, ")");
	.wait(100);
	!leaddooropening(WingAgent, X + X3 - 1, Y + Y3 - 1);
	
	//!leadStepAwayFromSwitch(Ag, Direction, Sdx);
	
 	?iam(N);
	.print("Schicke ", ClosestAgent, " in den Pferch");
	.send(ClosestAgent, tell, getinformation(N, Step));
	!waitForAllAgentsInFormation(1, ClosestAgent);
	.print(ClosestAgent, " ist im Pferch angekommen");
	.abolish(information(_, _));	   	
	
	.print("Schicke ", WingAgent, " in den Pferch");
	.send(WingAgent, tell, getinformation(N, Step));
	!waitForAllAgentsInFormation(1, WingAgent);
	.print(WingAgent, " ist im Pferch angekommen");
	.abolish(information(_, _));	   	
	
	
	-switchDetected(S, X, Y, T)[source(Cg)];
	//-relativeDirection(_,_,_).
	-closestAgent(_);
	-agentGroup(Ag,Bg);
	-currentSwitch(S,X,Y).
	


+!dooropeningPending(Ag, X, Y): arrivedAtSwitch(X,Y)[source(Ag)]
<-
	.print(Ag, " sagte mir, er sei am Switch angekommen");
	-arrivedAtSwitch(X,Y)[source(Ag)];
	+isAtSwitch(Ag).
	
	
+!dooropeningPending(Ag, X, Y)
<-
	.print("warte auf Erfolg (do) von ", Ag);
	.wait(2000);
	!dooropeningPending(Ag, X, Y).
	
	
+!leaddooropening(Ag, X, Y)
<-
	.wait(3000); //warten, falls serververbindung noch nicht hergestellt (nur bei trockentests)
	.print("sende ", Ag, " dass er den Switch oeffnen soll");
	.send(Ag, tell, openSwitch(X, Y));
	!dooropeningPending(Ag, X, Y).
	
	
//-!leaddooropening(_,_,_)
//<-
//	.print("Fehler beim Beaufsichtigen des Tueroeffnens.").

+!leadmarching(HelperList, Pos): .length(HelperList, AgentCount) & AgentCount <= (Pos - 1)
<- .print("An alle Agenten verschickt").


+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & not (isAtSwitch(Ag) | iam(Ag))
<-  .print("sende ", Ag, " getinformation");
 	?step(Step);
 	?iam(N);
	.send(Ag, tell, getinformation(N, Step));
	!leadmarching(HelperList, Pos+1). 	
	

       	
+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & isAtSwitch(Ag)
<-  .print(Ag, " ist bereits mit einem Switch besch�ftigt");
	!leadmarching(HelperList, Pos+1).
	
	
+!leadmarching(HelperList, Pos): not (.length(HelperList, AgentCount) & AgentCount <= (Pos - 1)) & .nth(Pos - 1, HelperList, Ag) & iam(Ag)
<-  .print("ich laufe erst nachher los");
	!leadmarching(HelperList, Pos+1).
	
	
+!leadLookForSwitch(Ag, Bg, Direction) : rotateDirection(right, Direction, RDirection) & rotateDirection(left, Direction, LDirection)
<-	

		
	.wait(3000); //warten, falls serververbindung noch nicht hergestellt (nur bei trockentests)
	.print("sende ", Ag, " dass er einen Switch in Richtung ", RDirection, " suchen soll");
	.send(Ag, tell, startLookingForSwitch(RDirection));
	.print("sende ", Bg, " dass er einen Switch in Richtung ", LDirection, " suchen soll");
	.send(Bg, tell, startLookingForSwitch(LDirection));
	
	
	!switchlookingPending(Ag, Bg, Direction).
	
	
	
	
	
-!leadLookForSwitch(Ag, Bg, Direction)
<-
	.print("Kein passender Kontext fuer leadLookForSwitch").


+!switchlookingPending(Ag, Bg, Direction): 
	switchDetected(S, X, Y, T)[source(Cg)] & doorOpenerToggle(Cg, Dg)
<-
	.print(Cg, " sagte mir, bei (", X, ",", Y, ") sei ein Switch");
	+currentSwitch(S, X, Y);
	+ison(S, X, Y, T); // ison verwenden ist unschoen
	?iam(N);
	?ison(N, X1, Y1, _);
	
	.print("Gebe Abbruchnachricht an ", Dg);
	.send(Dg, tell, switchFound); 
	
	?doorOpenerToggle(Cg, Dg);
	!getClosestAgent(Cg, Dg, S, X, Y);
	//-distanceToSwitch(_,_,_,_,_,_);
	!getRelativeDirections(S, X, Y);
	//?ison(Cg, Acx, Acy);
	//!getRelativeDirections(Cg, Acx, Acy); 
	//?ison(Dg, Adx, Ady);
	//!getRelativeDirections(Dg, Adx, Ady); 
	
	
	?closestAgent(ClosestAgent);
	?relateAxis(Axis, Direction);
	?relativeDirection(Axis, S, Sdx);
	//?formationDirection(Axis, ClosestAgent, Sdx);
	?doorOpenerToggle(ClosestAgent, FarestAgent);
	
	
	//!getBackInFormation(FarestAgent);
	
 	?step(Step);
 	?iam(N);
	.send(FarestAgent, tell, getinformation(N, Step));	
	!waitForAllAgentsInFormation(1, FarestAgent);
	.print(FarestAgent, " zurueckgepfiffen");
	.abolish(information(_, _));	   	
	
	?toggleSwitch(outside, Direction, X2, Y2);
	.print("Schicke ", ClosestAgent, " zu (", X + X2 -1, ",", Y + Y2 -1, ")");
	.wait(100);
	!leaddooropening(ClosestAgent, X + X2 -1 , Y + Y2 - 1).
		
	
	
-!switchlookingPending(_, _, _) : true
<-
	.print("Fehler beim Pending").
	
	
	
	
+!switchlookingPending(Ag, Bg, Direction)
<-
	.print("warte auf Erfolg (lfs) von ", Ag, " und ", Bg);
	.wait(2000);
	!switchlookingPending(Ag, Bg, Direction).
	
	
	
//+!getBackInFormation(FarestAgent)
//<-
	
//	?wayPointCount(W);
//	?wayPoint(W, FarestAgent, Dx, Dy);
//	.print("Schicke ", FarestAgent, " zurueck in Formation auf ", Dx, ",", Dy);
//	!leaddooropening(FarestAgent, Dx, Dy);
//	.print("Habe ", FarestAgent, " zurueckgepfiffen").
	
	
	
+!getClosestAgent(Ag, Bg, S, X, Y) 
<-	
	.send(Ag, tell, checkDistance(S, X, Y));
	.send(Bg, tell, checkDistance(S, X, Y));
	!getDistancePending(Ag, Bg, S, X, Y);
	
	!compareAgentDistance(Ag, Bg, S, X, Y); 
	
	
	
	-distanceToSwitch(_,_,_,_,_,_).
	
	
	
+!compareAgentDistance(Ag, Bg, S, X, Y) : distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] &
(DistA <= DistB)
<-
	.print("Naeherer Agent: ", Ag);
	+closestAgent(Ag).
	
+!compareAgentDistance(Ag, Bg, S, X, Y) : distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] &
(DistA > DistB)
<-
	.print("Naeherer Agent: ", Bg);
	+closestAgent(Bg).

	

+!getDistancePending(Ag, Bg, S, X, Y) : 
	distanceToSwitch(S, X, Y, DistA, _)[source(Ag)] & distanceToSwitch(S, X, Y, DistB, _)[source(Bg)] 	
<-	
	.print(Ag, " sagt mir er hat Abstand ", DistA, " zu ", S);
	.print(Bg, " sagt mir er hat Abstand ", DistB, " zu ", S).
	

+!getDistancePending(Ag, Bg, S, X, Y) 
<-	
	.print("Warte auf Distanzen");
	.wait(1000);
	!getDistancePending(Ag, Bg, S, X, Y).

-!getDistancePending(Ag, Bg, S, X, Y)
<-
	.print("getDistancePending fehlgeschlagen.").
	
	
	
//+!leadStepAwayFromSwitch(ClosestAgent, Direction, Sdx)
//<-
	
//	.print("Lasse ", ClosestAgent, " den Schalter freimachen");
//	.send(ClosestAgent, tell, stepAwayFromSwitch(Direction, Sdx));
//	.print("achieve gesendet");
//	!stepAwayFromSwitchPending(ClosestAgent).
	
	
	
//+!stepAwayFromSwitchPending(Ag) : steppedAway[source(Ag)]
//<-
//	.print(Ag, " ist vom Schalter zurueckgetreten");
//	-steppedAway[source(Ag)].
	
	
//+!stepAwayFromSwitchPending(Ag)
//<-
//	.wait(1000);
//	.print("warte auf Erfolg (safs)");
//	!stepAwayFromSwitchPending(Ag).
	
	
	
	
+!getRelativeDirections(S, X, Y) 
<-	
	!getRelativeDirection(xAxis, S, X);
	!getRelativeDirection(yAxis, S, Y).
	//.wait(100);
	//?relativeDirection(xAxis, S, Sdx);
	//?relativeDirection(yAxis, S, Sdy);
	//.print(S, " liegt im ", Sdx, " und ", Sdy).
	
+!getRelativeDirection(Axis, S, X) : Axis = xAxis & iam(N) & ison(N, Ax, Ay, _) & (X > Ax)
<- 
+relativeDirection(Axis, S, east).

+!getRelativeDirection(Axis, S, X) : Axis = xAxis & iam(N) & ison(N, Ax, Ay, _) & (X = Ax)
<- 
+relativeDirection(Axis, S, neutral).

+!getRelativeDirection(Axis, S, X) : Axis = xAxis & iam(N) & ison(N, Ax, Ay, _) & (X < Ax)
<- 
+relativeDirection(Axis, S, west).


+!getRelativeDirection(Axis, S, Y) : Axis = yAxis & iam(N) & ison(N, Ax, Ay, _) & (Y > Ay)
<- 
+relativeDirection(Axis, S, south).

+!getRelativeDirection(Axis, S, Y) : Axis = yAxis & iam(N) & ison(N, Ax, Ay, _) & (Y = Ay)
<- 
+relativeDirection(Axis, S, neutral).

+!getRelativeDirection(Axis, S, Y) : Axis = yAxis & iam(N) & ison(N, Ax, Ay, _) & (Y < Ay)
<- 
+relativeDirection(Axis, S, north). 
